/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
function setCurrAddr(longitude, latitude){
    var geocoder; 
    var lnglatXY = new AMap.LngLat(longitude, latitude);//需转为地址描述的坐标
    AMap.service(["AMap.Geocoder"], function() {       
        geocoder = new AMap.Geocoder({
            radius: 100,
            extensions: "all"
        });
    //逆地理编码
        geocoder.getAddress(lnglatXY, function(status, result){
        //取回逆地理编码结果
            if(status === 'complete' && result.info === 'OK'){
                $("#addr_txt").val(result.regeocode.formattedAddress);
                var marker = new AMap.Marker({
                    map:map,
                    icon: "http://webapi.amap.com/images/0.png",
                    position: lnglatXY,
                    offset: new AMap.Pixel(-10, -34)
                });
                map.setFitView();
            }
        });
    });
}

 var onSuccess = function(position) {
    alert('Latitude: '          + position.coords.latitude          + '\n' +
          'Longitude: '         + position.coords.longitude         + '\n' +
          'Altitude: '          + position.coords.altitude          + '\n' +
          'Accuracy: '          + position.coords.accuracy          + '\n' +
          'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
          'Heading: '           + position.coords.heading           + '\n' +
          'Speed: '             + position.coords.speed             + '\n' +
          'Timestamp: '         + position.timestamp                + '\n');
    setCurrAddr(position.coords.longitude, position.coords.latitude);
};

// onError Callback receives a PositionError object
//
function onError(error) {
    alert('code: '    + error.code    + '\n' +
          'message: ' + error.message + '\n');
}

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        console.warn("sssssssss");
        console.log('Received Event: ' + id);
        $('#addr_txt').textinput({ mini: true });
        $('#addr_txt').bind( "change", function(event, ui) {
            alert($("#addr_txt").val());
            placeSearch($("#addr_txt").val());
        });
        //placeSearch();
        navigator.geolocation.getCurrentPosition(onSuccess, onError);
    }
};
